(* tests on simplification
   author: Walther Neuper
   061019
   (c) due to copyright terms

use"../smltest/IsacKnowledge/simplify.sml";
use"simplify.sml";
*)

"--------------------------------------------------------";
"--------------------------------------------------------";
"table of contents --------------------------------------";
"--------------------------------------------------------";
"----------- CAS-command Simplify -----------------------";
"----------- append inform with final result ------------";
"--------------------------------------------------------";
"--------------------------------------------------------";
"--------------------------------------------------------";

val thy = @{theory "Simplify"};

"----------- CAS-command Simplify -----------------------";
"----------- CAS-command Simplify -----------------------";
"----------- CAS-command Simplify -----------------------";
(*============ inhibit exn WN120321 ==============================================
WN120321.TODO reanimate test/../simplify.sml: CAS-command Simplify

reset_states ();
CalcTree [([], ("e_domID", ["e_pblID"], ["e_metID"]))];
Iterator 1;
moveActiveRoot 1;
replaceFormula 1 "Simplify (2*a + 3*a)";
autoCalculate' 1 (Step 1);
autoCalculate' 1 CompleteCalc;
val ((pt,p),_) = get_calc 1;
val Form res = (#1 o pt_extract) (pt, ([],Res)); show_pt pt; term2str res;
if p = ([], Res) andalso term2str res = "5 * a" then ()
else error "simplify.sml: diff.behav. CAScmd: Simplify (2*a + 3*a)";
============ inhibit exn WN120321 ==============================================*)


"----------- append inform with final result ------------";
"----------- append inform with final result ------------";
"----------- append inform with final result ------------";
reset_states ();
CalcTree [(["Term ((14 * x * y) / ( x * y ))", "normalform N"],
	("Rational", ["rational","simplification"], ["simplification","of_rationals"]))];
Iterator 1;
moveActiveRoot 1;
autoCalculate' 1 CompleteCalcHead;
val ((pt,p),_) = get_calc 1; show_pt pt; 
(*[
(([], Frm), Simplify (14 * x * y / (x * y)))] *)
pt_extract (pt, p); (*determines SOME (Apply_Method ["simplification", "of_rationals"])*)

autoCalculate' 1 (Step 1);
val ((pt,p),_) = get_calc 1; show_pt pt;
(*[
(([], Frm), Simplify (14 * x * y / (x * y))),
(([1], Frm), 14 * x * y / (x * y))] *)

appendFormula 1 "14" (*|> Future.join*);
val ((pt,p),_) = get_calc 1; show_pt pt;
(*[
(([], Frm), Simplify (14 * x * y / (x * y))),
(([1], Frm), 14 * x * y / (x * y)),
(([1,1], Frm), 14 * x * y / (x * y)),
(([1,1], Res), 14 * (x * y) / (x * y)),
(([1,2], Res), 14 / 1),
(([1,3], Res), 14),
(([1], Res), 14)]*)

autoCalculate' 1 (Step 1);
val ((pt,p),_) = get_calc 1; show_pt pt;
(*[
(([], Frm), Simplify (14 * x * y / (x * y))),
(([1], Frm), 14 * x * y / (x * y)),
(([1,1], Frm), 14 * x * y / (x * y)),
(([1,1], Res), 14 * (x * y) / (x * y)),
(([1,2], Res), 14 / 1),
(([1,3], Res), 14),
(([1], Res), 14),
(([], Res), 14)] *)
val Form res = (#1 o pt_extract) (pt, ([],Res));
if p = ([], Res) andalso term2str res = "14" then ()
else error "simplify.sml: append inform with final result changed";

