(* Title: tests on Tools
   Author: Walther Neuper WN071229,
   (c) due to copyright terms
*)
val thy = @{theory "Real"};

"-----------------------------------------------------------------";
"table of contents -----------------------------------------------";
"-----------------------------------------------------------------";
"----------- fun matchsub ----------------------------------------";
"----------- fun or2list: HOL.disj HOL.eq HOL.True HOL.False etc -";
"-----------------------------------------------------------------";
"-----------------------------------------------------------------";
"-----------------------------------------------------------------";


"----------- fun matchsub ----------------------------------------";
"----------- fun matchsub ----------------------------------------";
"----------- fun matchsub ----------------------------------------";
if matchsub thy (str2term "(a + (b + c))") (str2term "?x + (?y + ?z)")
then () else error "tools.sml matchsub a + (b + c)";

if matchsub thy (str2term "(a + (b + c)) + d") (str2term "?x + (?y + ?z)")
then () else error "tools.sml matchsub (a + (b + c)) + d";


"----------- fun or2list: HOL.disj HOL.eq HOL.True HOL.False etc -";
"----------- fun or2list: HOL.disj HOL.eq HOL.True HOL.False etc -";
"----------- fun or2list: HOL.disj HOL.eq HOL.True HOL.False etc -";
"see: --------- search for Or_to_List ---";
case or2list @{term True} of Const ("Tools.UniversalList", _) => ()
  | _ => error "Tools.UniversalList changed";
case or2list @{term False} of Const ("List.list.Nil", _) => ()
  | _ => error "Tools.UniversalList changed";
val t =  (str2term "x=3");
if term2str (or2list t) = "[x = 3]" then ()
else error "or2list changed";
val t =  (str2term "x=3 | x=-3 | x=0");
if term2str (or2list t) = "[x = 3, x = -3, x = 0]" then ()
else error "HOL.eq ? HOL.disj ? changed";

