header {* Quick introduction to ML, session 2 *}
theory ML2_Functions imports Isac begin

text{*
This course follows the book:
J.D.Ullmann, Elements of ML Programming. Prenctice Hall 1998.
Contents:

section {* 3.1 Functions *}
ML {*
fun add x y = x + y;
add 2 3;
add 3 4;
fun mult x y = x * y;
mult 2 3;
*}
ML {*
val plus3 = add 3;
plus3 4;
*}
ML {*
fun calc op_ x y = op_ (x, y);
*}
ML {*
op+
*}
ML {*
val op_ = op +;
val add' = calc op_;
add' 3 4;
*}
ML {*
val op_ = op *;
val add' = calc op_;
add' 3 4;
*}

section {* 3.2 Recursive Functions *}
ML {*
fun print [] = "";
print [];
(*print [1,2,3] exception Match raised*)
*}
ML {*
fun print [] = ""
  | print (x :: xs) = "123"; (*Value identifier x,(xs) has not been referenced. *)
print [];
print [1,2,3];
print [1,2,3,4,5,6,7]
*}
ML {*
fun print [] = ""
  | print (_ :: _) = "123";
print [];
print [1,2,3,4,5,6,7]
*}
ML {*
fun print [] = "]"
  | print (x :: xs) = (string_of_int x) ^ ", " ^ print xs;
print [];
print [1,2,3];
print [1,2,3,4,5,6,7]
*}
ML {*
fun print [] =  (writeln "print []: "; "]")
  | print (x :: xs) = 
      (writeln "print (x :: xs): x = "; (string_of_int x) ^ ", " ^ 
      (writeln (string_of_int x); print xs));
*}
ML {*
print [];
print [1,2,3];
*}
ML {*
1;
"xcv";
writeln "asd";
*}
section {* see src/Pure/library.ML, lists as sets *}
ML {*
member;
member op = [1,2,3,4,5] 3;
member op = [1,2,3,4,5] 7;
*}
ML {*
insert;
Library.insert;
fun insert eq x xs = if member eq xs x then xs else x :: xs;
*}
ML {*
insert op = 1 [1,2,3];
insert op = 4 [1,2,3];
*}
ML {*
insert;
Library.insert;
fun insert eq x xs = 
  if member eq xs x 
  then (writeln "then"; xs) 
  else (writeln "else"; x :: xs);
insert op = 1 [1,2,3];
insert op = 4 [1,2,3];
*}

ML {*
merge;
*}

ML {*
merge op = ([], []);
merge op = ([1,2], []);
merge op = ([], [4,5]);
merge op = ([1,2], [4,5]);
merge op = ([3,4], [4,5]);
*}

ML {*
union;
*}

ML {*
union op = [3,4] [4,5];
*}
end
