(*  Title:      ~~test/../Interpret/ptyps.thy
    Author:     Walther Neuper
*)

theory ptyps
imports Isac
begin

text {*
  *setup* KEStore_Elems.add_pbts is impossible in *.sml files.
  The respective test/../ptyps.sml is called in Test_Isac.thy.
*}

ML {*
"-ptyps.thy: store test-pbtyps by 'setup' ------------------------";
"-ptyps.thy: store test-pbtyps by 'setup' ------------------------";
"-ptyps.thy: store test-pbtyps by 'setup' ------------------------";
*}
setup {* KEStore_Elems.add_pbts
[(prep_pbt thy "pbl_test_refine" [] e_pblID
  (["refine", "test"], [], e_rls, NONE, [])),
(prep_pbt @{theory DiffApp} "pbl_pbla" [] e_pblID
  (["pbla", "refine", "test"],         
  [("#Given", ["fixedValues a_a"])], e_rls, NONE, [])),
(prep_pbt @{theory DiffApp} "pbl_pbla1" [] e_pblID
  (["pbla1","pbla", "refine", "test"], 
  [("#Given", ["fixedValues a_a","maximum a_1"])], e_rls, NONE, [])),
(prep_pbt @{theory DiffApp} "pbl_pbla2" [] e_pblID
  (["pbla2","pbla", "refine", "test"], 
  [("#Given", ["fixedValues a_a","valuesFor a_2"])], e_rls, NONE, [])),
(prep_pbt @{theory DiffApp} "pbl_pbla2x" [] e_pblID
  (["pbla2x","pbla2","pbla", "refine", "test"],
  [("#Given", ["fixedValues a_a","valuesFor a_2","functionOf a2_x"])], 
  e_rls, NONE, [])),
(prep_pbt @{theory DiffApp} "pbl_pbla2y" [] e_pblID
  (["pbla2y","pbla2","pbla", "refine", "test"],
  [("#Given" ,["fixedValues a_a","valuesFor a_2","boundVariable a2_y"])], 
  e_rls, NONE, [])),
(prep_pbt @{theory DiffApp} "pbl_pbla2z" [] e_pblID
  (["pbla2z","pbla2","pbla", "refine", "test"],
  [("#Given" ,["fixedValues a_a","valuesFor a_2","interval a2_z"])], 
  e_rls, NONE, [])),
(prep_pbt @{theory DiffApp} "pbl_pbla3" [] e_pblID
 (["pbla3","pbla", "refine", "test"],
  [("#Given" ,["fixedValues a_a","relations a_3"])], 
  e_rls, NONE, []))]
*}

(*ML_file "ptyps.sml"    ... is called in Test_Isac.thy *)

end
