(* Title:  testexamples for Root, radicals
   Author: Walther Neuper
   (c) due to copyright terms
 *)
"--------------------------------------------------------";
"table of contents --------------------------------------";
"--------------------------------------------------------";
"----------- rls Root_erls ------------------------------";
"--------------------------------------------------------";
"--------------------------------------------------------";

val thy = @{theory "Root"};
val ctxt = Proof_Context.init_global thy;

"----------- rls Root_erls ------------------------------";
"----------- rls Root_erls ------------------------------";
"----------- rls Root_erls ------------------------------";
val t = str2term "sqrt 1";
val SOME (t',_) = rewrite_set_ thy false Root_erls t;
if term2str t' = "1" then () else error "root.sml: diff.behav. sqrt 1";

val t = str2term "sqrt -1";
val NONE = rewrite_set_ thy false Root_erls t;

val t = str2term "sqrt 0";
val SOME (t',_) = rewrite_set_ thy false Root_erls t;
if term2str t' = "0" then () else error "root.sml: diff.behav. sqrt 1";

